#!/bin/sh
# /www/cgi-bin/ponte2.cgi 

cat <<EOF
Content-type: text/html

<HTML><HEAD><TITLE>ponte2 - return page</TITLE>

<style type="text/css">
body {
   background-color: #000000;
   font-family: monospace;
   font-weight: bold;
   font-size: 10pt;
   margin-left: 1%; margin-right: 2%;
   color: white;
}

</style>
</HEAD>
<BODY>
please, don't worry be patient...
<pre>
EOF


get_parameter () {
  echo "$query" | tr '&' '\n' | grep "^$1=" | head -1 | sed "s/.*=//" 
}

oggi=$(date)
acl_list=/etc/acl_list.conf
IP0="0.0.0.0"
noMac="--:--:--:--:--:--"
confDir="/etc/repeater"

# discover request method
if [ "$REQUEST_METHOD" = POST ]; then
  query=$( head --bytes="$CONTENT_LENGTH" )
  else
  query="$QUERY_STRING"
fi

##### 
with_Profile=0
with_Simlink=0
main_conf=$confDir/ponte2.conf
run_string=/etc/ponte2
# read inputs
wp=$( get_parameter wp )
profileName=$( get_parameter profileName )
if [ -n "$wp" ]; then
  if [ -n "$profileName" ]; then
    with_Profile=1
    main_conf=$confDir/ponte2$profileName.conf
    run_string="/etc/ponte2 -p $profileName"
  else
    echo "ERROR: profile name not found"
    exit 1
  fi
  else
  with_Profile=0
fi  

simlink=$( get_parameter simlink )
if [ -n "$simlink" ]; then
  with_Simlink=1
fi

wrapper=$( get_parameter wrapper )

if [ $wrapper == 3 ]; then
  oldProfileName=$( get_parameter oldProfileName )
  if [ -n "$oldProfileName" ]; then
    main_conf=$confDir/ponte2$oldProfileName.conf
    run_string="/etc/ponte2 -p $oldProfileName"
    cleanWrap=/tmp/wrapper_ponte2.sh
    cat > $cleanWrap << EOF
#!/bin/sh
# run $run_string
$run_string
EOF
    chmod 755 $cleanWrap
    exec $cleanWrap  
    else
    echo "ERROR: old profile name not found"
    exit 1
  fi
fi

##### go !
echo "# runtime conf file for ponte2" > $main_conf
# get parameters
echo "only_AP=0" >> $main_conf
echo "bridge_mode=0" >> $main_conf
echo "#"
echo "# FON HotSpot" >> $main_conf
echo "#--------" >> $main_conf
fonMode=$( get_parameter p3 )
fonHotSpot=$( get_parameter fon )
rate=$( get_parameter rate )
echo "fonMode="$fonMode >> $main_conf
echo "fonHotSpot="$fonHotSpot >> $main_conf
echo "rate="$rate >> $main_conf
echo "#" >> $main_conf

echo "# WEP and WPA parameters" >> $main_conf
echo "#-----------------------" >> $main_conf

# WEP
kwep=$( get_parameter p17 )
kwepSta=$( get_parameter p22 )
if [ $kwepSta == 1 ] ; then
  WepKey_ath1=$( get_parameter p11a )
  echo "WepKey_ath1="$WepKey_ath1 >> $main_conf
fi
if [ $kwep == 2 ] ; then
  WepKey_ath0=$( get_parameter p18b )
  echo "WepKey_ath0="$WepKey_ath0 >> $main_conf
fi

# WPA
kwpa=$( get_parameter p23 )
echo "kwpa="$kwpa >> $main_conf
if ! [ $kwpa == 0 ]; then
  WapPassPhrase=$( get_parameter p24 )
  p23wa=$( get_parameter p23wa )
  case $p23wa in
    1) WapAlg=TKIP ;;
    2) WapAlg=CCMP ;;
    3) WapAlg="TKIP CCMP";;
  esac
  WapSsid=$( get_parameter p10 )

  echo "WapAlg="$WapAlg >> $main_conf
  echo "WapPassPhrase="$WapPassPhrase >> $main_conf
  echo "WapSsid="$WapSsid >> $main_conf
  kwepSta=3
fi

kwpa_ap=$( get_parameter p23_ap )
echo "kwpa_ap="$kwpa_ap >> $main_conf
if ! [ $kwpa_ap == 0 ]; then
  WapPassPhrase_ap=$( get_parameter p24_ap )
  p23wa_ap=$( get_parameter p23wa_ap )
  case $p23wa_ap in
    1) WapAlg_ap=TKIP ;;
    2) WapAlg_ap=CCMP ;;
    3) WapAlg_ap="TKIP CCMP";;
  esac
  echo "WapAlg_ap="$WapAlg_ap >> $main_conf
  echo "WapPassPhrase_ap="$WapPassPhrase_ap >> $main_conf
  kwep=3
fi

echo "kwep="$kwep >> $main_conf
echo "kwepSta="$kwepSta >> $main_conf

echo "#" >> $main_conf
echo "# ACL MAC filter" >> $main_conf
echo "#---------------" >> $main_conf
aclMode=$( get_parameter p7 )
echo "aclMode="$aclMode >> $main_conf
if [ $aclMode == 1 ]; then
  if [ -e $acl_list ]; then
    mv $acl_list $acl_list.sav
  fi
  m00=$( get_parameter m00 )
  m01=$( get_parameter m01 )
  m02=$( get_parameter m02 )
  m03=$( get_parameter m03 )
  m04=$( get_parameter m04 )
  m05=$( get_parameter m05 )
  echo $m00:$m01:$m02:$m03:$m04:$m05 > $acl_list
  
  m10=$( get_parameter m10 )
  m11=$( get_parameter m11 )
  m12=$( get_parameter m12 )
  m13=$( get_parameter m13 )
  m14=$( get_parameter m14 )
  m15=$( get_parameter m15 )
  echo $m10:$m11:$m12:$m13:$m14:$m15 >> $acl_list
  
  m20=$( get_parameter m20 )
  m21=$( get_parameter m21 )
  m22=$( get_parameter m22 )
  m23=$( get_parameter m23 )
  m24=$( get_parameter m24 )
  m25=$( get_parameter m25 )
  echo $m20:$m21:$m22:$m23:$m24:$m25 >> $acl_list 
     
  m30=$( get_parameter m30 )
  m31=$( get_parameter m31 )
  m32=$( get_parameter m32 )
  m33=$( get_parameter m33 )
  m34=$( get_parameter m34 )
  m35=$( get_parameter m35 )
  echo $m30:$m31:$m32:$m33:$m34:$m35 >> $acl_list  
    
  m40=$( get_parameter m40 )
  m41=$( get_parameter m41 )
  m42=$( get_parameter m42 )
  m43=$( get_parameter m43 )
  m44=$( get_parameter m44 )
  m45=$( get_parameter m45 )
  echo $m40:$m41:$m42:$m43:$m44:$m45 >> $acl_list 
    
  m50=$( get_parameter m50 )
  m51=$( get_parameter m51 )
  m52=$( get_parameter m52 )
  m53=$( get_parameter m53 )
  m54=$( get_parameter m54 )
  m55=$( get_parameter m55 )
  echo $m50:$m51:$m52:$m53:$m54:$m55 >> $acl_list  
fi
echo "#" >> $main_conf

echo "# ath1 parameters" >> $main_conf
echo "#----------------" >> $main_conf
ath1_mode=$( get_parameter p9 )
echo "ath1_mode="$ath1_mode >> $main_conf
case $ath1_mode in
  2) 
  Target_AP=$( get_parameter p10 )
  if ! [ -n "$Target_AP" ]; then
    echo "ERROR: Source Master SSID not indicated"
    exit 1
  fi  
  echo "Target_AP="$Target_AP >> $main_conf
  ;;
  3)
  tm0=$( get_parameter tm0 )
  tm1=$( get_parameter tm1 )
  tm2=$( get_parameter tm2 )
  tm3=$( get_parameter tm3 )
  tm4=$( get_parameter tm4 )
  tm5=$( get_parameter tm5 )
  Target_AP=$tm0:$tm1:$tm2:$tm3:$tm4:$tm5 
  if [ $Target_AP == $noMac ] ; then
    echo "ERROR: Source Master MAC address not valid"
    exit 1  
  fi
  echo "Target_AP="$Target_AP >> $main_conf
  ;;
esac

kdhcpc=$( get_parameter p12 )
echo "kdhcpc="$kdhcpc >> $main_conf
max_retries=$( get_parameter maxatt )
echo "max_retries="$max_retries >> $main_conf
if [ $kdhcpc == 0 ]; then
# get IP for ath1 --> so, for Fonera
  ist0=$( get_parameter ist0 )
  ist1=$( get_parameter ist1 )
  ist2=$( get_parameter ist2 )
  ist3=$( get_parameter ist3 )
  MASK_ath1=$( get_parameter p13 )
  # get dgw 
  dgw0=$( get_parameter dgw0 )
  dgw1=$( get_parameter dgw1 )
  dgw2=$( get_parameter dgw2 )
  dgw3=$( get_parameter dgw3 )
  # get IP for nameserver1
  ns10=$( get_parameter ns10 )
  ns11=$( get_parameter ns11 )
  ns12=$( get_parameter ns12 )
  ns13=$( get_parameter ns13 )
  echo "IP_ath1="$ist0.$ist1.$ist2.$ist3 >> $main_conf
  echo "MASK_ath1="$MASK_ath1 >> $main_conf
  echo "DFGW="$dgw0.$dgw1.$dgw2.$dgw3 >> $main_conf
  echo "NAMESERVER="$ns10.$ns11.$ns12.$ns13 >> $main_conf
fi
echo "#" >> $main_conf

echo "# ath0 parameters" >> $main_conf
echo "#----------------" >> $main_conf
kssid=$( get_parameter p19 )
echo "kssid="$kssid >> $main_conf
if [ $kssid == 0 ]; then
  SSID_ath0=$( get_parameter p20 )
  echo "SSID_ath0="$SSID_ath0 >> $main_conf
fi
hideSSID=$( get_parameter p8 )
echo "hideSSID="$hideSSID >> $main_conf
AP_ch=$( get_parameter AP_ch )
echo "AP_ch="$AP_ch >> $main_conf
# get IP for ath0 (ibr<0-3>)
ibr0=$( get_parameter ibr0 )
ibr1=$( get_parameter ibr1 )
ibr2=$( get_parameter ibr2 )
ibr3=$( get_parameter ibr3 )  
IP_ath0=$ibr0.$ibr1.$ibr2.$ibr3
MASK_ath0=$( get_parameter p14 )
echo "IP_ath0="$IP_ath0 >> $main_conf
echo "MASK_ath0="$MASK_ath0 >> $main_conf
kdhcp_ath0=$( get_parameter p5 )
echo "kdhcp_ath0="$kdhcp_ath0 >> $main_conf
if [ $kdhcp_ath0 == 1 ]; then
 # get pool for dnsmasq on ath0
  s0=$( get_parameter s0 )
  s1=$( get_parameter s1 )
  s2=$( get_parameter s2 )
  s3=$( get_parameter s3 )
  s_dhcp=$s0.$s1.$s2.$s3
  e0=$( get_parameter e0 )
  e1=$( get_parameter e1 )
  e2=$( get_parameter e2 )
  e3=$( get_parameter e3 )
  e_dhcp=$e0.$e1.$e2.$e3
  leaseTime=$( get_parameter p21 )
  echo  "s_dhcp="$s_dhcp >> $main_conf
  echo  "e_dhcp="$e_dhcp >> $main_conf  
fi

echo "#" >> $main_conf
echo "# eth0 parameters" >> $main_conf
echo "#----------------" >> $main_conf
iar0=$( get_parameter iar0 )
iar1=$( get_parameter iar1 )
iar2=$( get_parameter iar2 )
iar3=$( get_parameter iar3 )
IP_eth0=$iar0.$iar1.$iar2.$iar3
echo "IP_eth0="$IP_eth0 >> $main_conf
MASK_eth0=$( get_parameter p14a )
echo "MASK_eth0="$MASK_eth0 >> $main_conf

echo "#" >> $main_conf
echo "# port forward" >> $main_conf
echo "#-------------" >> $main_conf
btorrent=$( get_parameter p15 )
echo "btorrent="$btorrent >> $main_conf
if [ $btorrent == 1 ] ; then
  cb=$( get_parameter cb )
  echo "IP_client_btorrent="$cb >> $main_conf  
fi
xmule=$( get_parameter p16 )
echo "xmule="$xmule >> $main_conf
if [ $xmule == 1 ] ; then
  cm=$( get_parameter cm )
 echo "IP_client_xmule="$cm >> $main_conf 
fi
echo "#" >> $main_conf
ru1=$( get_parameter r1 )
if [ -n "$ru1" ]; then
  echo "r1=1" >> $main_conf
  ip1=$( get_parameter ip1 )
  port1a=$( get_parameter port1a )
  port1b=$( get_parameter port1b )
  prot1=$( get_parameter prot1 )
  echo "ip1="$ip1 >> $main_conf
  echo "port1a="$port1a >> $main_conf
  echo "port1b="$port1b >> $main_conf
  echo "prot1="$prot1 >> $main_conf
  else
  echo "r1=0" >> $main_conf  
fi

ru2=$( get_parameter r2 )
if [ -n "$ru2" ]; then
  echo "r2=1" >> $main_conf
  ip2=$( get_parameter ip2 )
  port2a=$( get_parameter port2a )
  port2b=$( get_parameter port2b )
  prot2=$( get_parameter prot2 )
  echo "ip2="$ip2 >> $main_conf
  echo "port2a="$port2a >> $main_conf
  echo "port2b="$port2b >> $main_conf
  echo "prot2="$prot2 >> $main_conf
  else
  echo "r2=0" >> $main_conf  
fi

ru3=$( get_parameter r3 )
if [ -n "$ru3" ]; then
  echo "r3=1" >> $main_conf
  ip3=$( get_parameter ip3 )
  port3a=$( get_parameter port3a )
  port3b=$( get_parameter port1b )
  prot3=$( get_parameter prot3 )
  echo "ip3="$ip3 >> $main_conf
  echo "port3a="$port3a >> $main_conf
  echo "port3b="$port3b >> $main_conf
  echo "prot3="$prot3 >> $main_conf
  else
  echo "r3=0" >> $main_conf  
fi

ru4=$( get_parameter r4 )
if [ -n "$ru4" ]; then
  echo "r4=1" >> $main_conf
  ip4=$( get_parameter ip4 )
  port4a=$( get_parameter port4a )
  port4b=$( get_parameter port1b )
  prot4=$( get_parameter prot4 )
  echo "ip4="$ip4 >> $main_conf
  echo "port4a="$port4a >> $main_conf
  echo "port4b="$port4b >> $main_conf
  echo "prot4="$prot4 >> $main_conf
  else
  echo "r4=0" >> $main_conf  
fi

ru5=$( get_parameter r5 )
if [ -n "$ru5" ]; then
  echo "r5=1" >> $main_conf
  ip5=$( get_parameter ip5 )
  port5a=$( get_parameter port5a )
  port5b=$( get_parameter port1b )
  prot5=$( get_parameter prot5 )
  echo "ip5="$ip5 >> $main_conf
  echo "port5a="$port5a >> $main_conf
  echo "port5b="$port5b >> $main_conf
  echo "prot5="$prot5 >> $main_conf
  else
  echo "r5=0" >> $main_conf  
fi
echo "# have fun! " >> $main_conf
chmod 755 $main_conf
sleep 1

# run options control
if [ $with_Simlink == 1 ]; then
  cleanWrap=/etc/init.d/S98ponte2
  cat > $cleanWrap << EOF
#!/bin/sh
$run_string
EOF
  chmod 755 $cleanWrap
fi

case $wrapper in
  1) 
  cleanWrap=/tmp/wrapper_ponte2.sh
  cat > $cleanWrap << EOF
#!/bin/sh
# run $run_string
$run_string
EOF
  chmod 755 $cleanWrap
  exec $cleanWrap  
  ;;
  2)
  cat $main_conf
  ;;
esac

cat <<EOF
Content-type: text/html

</pre>
</body></html>
EOF

# have fun!



