#!/bin/sh
# /www/cgi-bin/ponte2robin.cgi 

cat <<EOF
Content-type: text/html

<HTML><HEAD><TITLE>ponte2bat - return page</TITLE>

<style type="text/css">
body {
   background-color: #000000;
   font-family: monospace;
   font-weight: bold;
   font-size: 10pt;
   margin-left: 1%; margin-right: 2%;
   color: white;
}

</style>
</HEAD>
<BODY>
please, don't worry be patient...
<pre>
EOF

fatal_error () {
   echo "$1"
   echo "Fatal Error   ->   aborting script"
   exit 1
}

get_parameter () {
  echo "$query" | tr '&' '\n' | grep "^$1=" | head -1 | sed "s/.*=//" 
}

oggi=$(date)
acl_list=/etc/acl_list.conf
IP0="0.0.0.0"
ns_FON="`cat /etc/resolv.conf.fon | grep "nameserver" | awk '{print $2}'`"
noMac="--:--:--:--:--:--"
confDir="/etc/batman"
main_conf=$confDir/ponte2bat.conf
bat_cwmin=$confDir/bat_cwmin
bat_run=$confDir/bat_run
run_string=/etc/ponte2bat

# discover request method
if [ "$REQUEST_METHOD" = POST ]; then
  query=$( head --bytes="$CONTENT_LENGTH" )
  else
  query="$QUERY_STRING"
fi

# read inputs
with_Simlink=0
simlink=$( get_parameter simlink )
[ -n "$simlink" ] && with_Simlink=1
if [ $with_Simlink == 1 ]; then
  cleanWrap=/etc/init.d/S98ponte2BAT
  cat > $cleanWrap << EOF
#!/bin/sh
$run_string
EOF
  chmod 755 $cleanWrap
fi

# /tmp/wrapper is wrote in any case
wrapper=$( get_parameter wrapper )
cleanWrap=/tmp/wrapper_ponte2bat.sh
cat > $cleanWrap << EOF
#!/bin/sh
$run_string
EOF
chmod 755 $cleanWrap

cwmin=$( get_parameter cwmin )
cat > $bat_cwmin << EOF
# etc/batman/bat_cwmin
cwmin=$cwmin
EOF

runmode=$( get_parameter runmode )
logport=$( get_parameter logport )
debuglevel=$( get_parameter debuglevel )
cat > $bat_run << EOF
# /etc/batman/bat_run
run_mode=$runmode
log_port=$logport
debug_level=$debuglevel
EOF
echo "# /etc/batman/ponte2bat.conf" > $main_conf
echo "only_AP=0" >> $main_conf
echo "bridge_mode=0" >> $main_conf
echo "# FON HotSpot" >> $main_conf
fonMode=$( get_parameter p3 )
fonHotSpot=$( get_parameter fon )
rate=$( get_parameter rate )
echo "fonMode="$fonMode >> $main_conf
echo "fonHotSpot="$fonHotSpot >> $main_conf
echo "rate="$rate >> $main_conf
echo " " >> $main_conf
echo " " >> $main_conf

echo "# WEP and WPA parameters" >> $main_conf
echo "#-----------------------" >> $main_conf
# WEP
kwep=$( get_parameter p17 )
if [ $kwep == 2 ] ; then
  WepKey_ath1=$( get_parameter p18b )
  echo "WepKey_ath1="$WepKey_ath1 >> $main_conf
fi
# WPA
kwpa_ap=$( get_parameter p23_ap )
echo "kwpa_ap="$kwpa_ap >> $main_conf
if ! [ $kwpa_ap == 0 ]; then
  WapPassPhrase_ap=$( get_parameter p24_ap )
  p23wa_ap=$( get_parameter p23wa_ap )
  case $p23wa_ap in
    1) WapAlg_ap=TKIP ;;
    2) WapAlg_ap=CCMP ;;
    3) WapAlg_ap="TKIP CCMP";;
  esac
  echo "WapAlg_ap="$WapAlg_ap >> $main_conf
  echo "WapPassPhrase_ap="$WapPassPhrase_ap >> $main_conf
  kwep=3
fi
echo "kwep="$kwep >> $main_conf
echo " " >> $main_conf
echo " " >> $main_conf
echo "# ACL MAC filter" >> $main_conf
echo "#---------------" >> $main_conf
aclMode=$( get_parameter p7 )
echo "aclMode="$aclMode >> $main_conf
if [ $aclMode == 1 ]; then
  if [ -e $acl_list ]; then
    mv $acl_list $acl_list.sav
  fi
  m00=$( get_parameter m00 )
  m01=$( get_parameter m01 )
  m02=$( get_parameter m02 )
  m03=$( get_parameter m03 )
  m04=$( get_parameter m04 )
  m05=$( get_parameter m05 )
  echo $m00:$m01:$m02:$m03:$m04:$m05 > $acl_list
  m10=$( get_parameter m10 )
  m11=$( get_parameter m11 )
  m12=$( get_parameter m12 )
  m13=$( get_parameter m13 )
  m14=$( get_parameter m14 )
  m15=$( get_parameter m15 )
  echo $m10:$m11:$m12:$m13:$m14:$m15 >> $acl_list
  m20=$( get_parameter m20 )
  m21=$( get_parameter m21 )
  m22=$( get_parameter m22 )
  m23=$( get_parameter m23 )
  m24=$( get_parameter m24 )
  m25=$( get_parameter m25 )
  echo $m20:$m21:$m22:$m23:$m24:$m25 >> $acl_list 
  m30=$( get_parameter m30 )
  m31=$( get_parameter m31 )
  m32=$( get_parameter m32 )
  m33=$( get_parameter m33 )
  m34=$( get_parameter m34 )
  m35=$( get_parameter m35 )
  echo $m30:$m31:$m32:$m33:$m34:$m35 >> $acl_list  
  m40=$( get_parameter m40 )
  m41=$( get_parameter m41 )
  m42=$( get_parameter m42 )
  m43=$( get_parameter m43 )
  m44=$( get_parameter m44 )
  m45=$( get_parameter m45 )
  echo $m40:$m41:$m42:$m43:$m44:$m45 >> $acl_list 
  m50=$( get_parameter m50 )
  m51=$( get_parameter m51 )
  m52=$( get_parameter m52 )
  m53=$( get_parameter m53 )
  m54=$( get_parameter m54 )
  m55=$( get_parameter m55 )
  echo $m50:$m51:$m52:$m53:$m54:$m55 >> $acl_list  
fi
echo " " >> $main_conf
echo " " >> $main_conf

echo "# BATMAN parameters" >> $main_conf
echo "#----------------" >> $main_conf
mesh_essid=$( get_parameter mesh_essid )
mesh_ch=$( get_parameter mesh_ch )
mesh_ogm=$( get_parameter mesh_ogm )
echo "mesh_essid="$mesh_essid >> $main_conf
echo "mesh_ch="$mesh_ch >> $main_conf
echo "mesh_ogm="$mesh_ogm >> $main_conf
ist0=$( get_parameter ist0 )
ist1=$( get_parameter ist1 )
ist2=$( get_parameter ist2 )
ist3=$( get_parameter ist3 )
IP_mesh="$ist0.$ist1.$ist2.$ist3"
[ $IP_mesh = $IP0 ] && fatal_error "The IP Address of the node is not indicated"
echo "IP_mesh="$IP_mesh >> $main_conf

MASK_mesh=$( get_parameter mask_mesh )
echo "MASK_mesh="$MASK_mesh >> $main_conf
vs0=$( get_parameter vs0 )
vs1=$( get_parameter vs1 )
vs2=$( get_parameter vs2 )
vs3=$( get_parameter vs3 )
echo "vs_bat="$vs0.$vs1.$vs2.$vs3 >> $main_conf
battype=$( get_parameter battype )
echo "battype="$battype >> $main_conf
case $battype in
	1)
	echo "# BATMAN CLIENT parameters" >> $main_conf
	echo "#----------------" >> $main_conf
	rclass=$( get_parameter rclass )
	echo "rclass="$rclass >> $main_conf
	ns10=$( get_parameter ns10 )
	ns11=$( get_parameter ns11 )
	ns12=$( get_parameter ns12 )
	ns13=$( get_parameter ns13 )
	ns_client="$ns10.$ns11.$ns12.$ns13"
	[ $ns_client = $IP0 ] && ns_client=$ns_FON
	echo "ns_client="$ns_client >> $main_conf
	pgw0=$( get_parameter pgw0 )
	pgw1=$( get_parameter pgw1 )
	pgw2=$( get_parameter pgw2 )
	pgw3=$( get_parameter pgw3 )
	echo "pgw_bat="$pgw0.$pgw1.$pgw2.$pgw3 >> $main_conf
	;;
	
	2)
	echo "# BATMAN gateway parameters" >> $main_conf
	echo "#----------------" >> $main_conf
	gclass=$( get_parameter gclass )
	echo "gclass="$gclass >> $main_conf
	echo " " >> $main_conf
	echo "# eth0 parameters" >> $main_conf
	echo "#----------------" >> $main_conf
	p12=$( get_parameter p12 )
	echo "kdhcp_eth0="$p12 >> $main_conf
	if ! [ $p12 == 1 ]; then
	# manual configuration 	
		lan0=$( get_parameter lan0 )
		lan1=$( get_parameter lan1 )
		lan2=$( get_parameter lan2 )
		lan3=$( get_parameter lan3 )
		echo "IP_eth0="$lan0.$lan1.$lan2.$lan3 >> $main_conf
		p13=$( get_parameter p13 )
		echo "MASK_eth0="$p13 >> $main_conf
		dgw0=$( get_parameter dgw0 )
		dgw1=$( get_parameter dgw1 )
		dgw2=$( get_parameter dgw2 )
		dgw3=$( get_parameter dgw3 )
		echo "DFGW="$dgw0.$dgw1.$dgw2.$dgw3 >> $main_conf
		ns0=$( get_parameter ns0 )
		ns1=$( get_parameter ns1 )
		ns2=$( get_parameter ns2 )
		ns3=$( get_parameter ns3 )
		ns_gateway="$ns0.$ns1.$ns2.$ns3"
		[ $ns_gateway = $IP0 ] && ns_gateway=$ns_FON
		echo "ns_gateway="$ns_gateway >> $main_conf
	fi
	;;
esac	
echo " " >> $main_conf
echo " " >> $main_conf

echo "# bat_AP parameters" >> $main_conf
echo "#----------------" >> $main_conf
echo "kssid=0" >> $main_conf
SSID_ath1=$( get_parameter p20 )
echo "SSID_ath1="$SSID_ath1 >> $main_conf
hideSSID=$( get_parameter p8 )
echo "hideSSID="$hideSSID >> $main_conf
# get IP for ath1 
NET_ath1=$( get_parameter net_ath1 )
MASK_ath1=$( get_parameter p14 )
ann_AP=$( get_parameter ann_AP )
ibr0=$( get_parameter ibr0 )
ibr1=$( get_parameter ibr1 )
ibr2=$( get_parameter ibr2 )
ibr3=$( get_parameter ibr3 )  
IP_ath1=$ibr0.$ibr1.$ibr2.$ibr3
echo "NET_ath1="$NET_ath1 >> $main_conf
echo "MASK_ath1="$MASK_ath1 >> $main_conf
echo "ann_AP="$ann_AP >> $main_conf
echo "IP_ath1="$IP_ath1 >> $main_conf
kdhcp_ath1=$( get_parameter p5 )
echo "kdhcp_ath1="$kdhcp_ath1 >> $main_conf
if [ $kdhcp_ath1 == 1 ]; then
 # get pool for dnsmasq on ath1
  s0=$( get_parameter s0 )
  s1=$( get_parameter s1 )
  s2=$( get_parameter s2 )
  s3=$( get_parameter s3 )
  s_dhcp=$s0.$s1.$s2.$s3
  e0=$( get_parameter e0 )
  e1=$( get_parameter e1 )
  e2=$( get_parameter e2 )
  e3=$( get_parameter e3 )
  e_dhcp=$e0.$e1.$e2.$e3
  leaseTime=$( get_parameter p21 )
  echo  "s_dhcp="$s_dhcp >> $main_conf
  echo  "e_dhcp="$e_dhcp >> $main_conf  
fi
echo " " >> $main_conf
echo " " >> $main_conf

echo "# port forward" >> $main_conf
echo "#-------------" >> $main_conf
echo "btorrent=0"$btorrent >> $main_conf
echo "xmule=0"$xmule >> $main_conf

case $wrapper in
  1) 
  cleanWrap=/tmp/wrapper_ponte2bat.sh
  cat > $cleanWrap << EOF
#!/bin/sh
# run $run_string
$run_string
EOF
  chmod 755 $cleanWrap
  exec $cleanWrap  
  ;;
  2)
  cat $main_conf
  ;;
esac

cat <<EOF
Content-type: text/html

</pre>
</body></html>
EOF

# have fun!



