#!/bin/sh
# /www/cgi-bin/ponte2.cgi 

cat <<EOF
Content-type: text/html
<HTML><HEAD><TITLE>ponte2dwr - return page</TITLE>

<style type="text/css">
body {
   background-color: #000000;
   font-family: monospace;
   font-weight: bold;
   font-size: 10pt;
   margin-left: 1%; margin-right: 2%;
   color: white;
}

</style>
</HEAD>
<BODY>
please, don't worry be patient...
<pre>
EOF


get_parameter () {
  echo "$query" | tr '&' '\n' | grep "^$1=" | head -1 | sed "s/.*=//" 
}

oggi=$(date)
acl_list=/etc/acl_list.conf
dns_conf=/etc/dnsmasq.conf
confDir="/etc"

# discover request method
if [ "$REQUEST_METHOD" = POST ]; then
  query=$( head --bytes="$CONTENT_LENGTH" )
  else
  query="$QUERY_STRING"
fi

##### 
with_Profile=0
with_Simlink=0
main_conf=$confDir/ponte2wb.conf
run_string=/etc/ponte2wb
# read inputs
wp=$( get_parameter wp )
profileName=$( get_parameter profileName )
if [ -n "$wp" ]; then
  if [ -n "$profileName" ]; then
    with_Profile=1
    main_conf=$confDir/ponte2wb_$profileName.conf
    run_string="/etc/ponte2wb -p $profileName"
  else
    echo "ERROR: profile name not found"
    exit 1
  fi
  else
  with_Profile=0
fi  

simlink=$( get_parameter simlink )
if [ -n "$simlink" ]; then
  with_Simlink=1
fi

wrapper=$( get_parameter wrapper )
if [ $wrapper == 3 ]; then
  oldProfileName=$( get_parameter oldProfileName )
  if [ -n "$oldProfileName" ]; then
    main_conf=$confDir/ponte2wb_$oldProfileName.conf
    run_string="/etc/ponte2wb -p $oldProfileName"
    cleanWrap=/tmp/wrapper_ponte2wb.sh
    cat > $cleanWrap << EOF
#!/bin/sh
# run $run_string
$run_string
EOF
    chmod 755 $cleanWrap
    exec $cleanWrap  
    else
    echo "ERROR: old profile name not found"
    exit 1
  fi
fi
##### go !
echo "# $main_conf" > $main_conf
echo "#" >> $main_conf
echo "# ath1 parameters" >> $main_conf
echo "#----------------" >> $main_conf
TargetSsid=$( get_parameter p2 )
echo "TargetSsid="$TargetSsid >> $main_conf

echo "# ath0 parameters" >> $main_conf
echo "#----------------" >> $main_conf
SSID_ap=$( get_parameter p4 )
echo "SSID_ap="$SSID_ap >> $main_conf
hideSSID=$( get_parameter p5 )
echo "hideSSID="$hideSSID >> $main_conf
aclMode=$( get_parameter p7 )
echo "aclMode="$aclMode >> $main_conf
if [ $aclMode == 1 ]; then
  if [ -e $acl_list ]; then
    mv $acl_list $acl_list.sav
  fi
  m00=$( get_parameter m00 )
  m01=$( get_parameter m01 )
  m02=$( get_parameter m02 )
  m03=$( get_parameter m03 )
  m04=$( get_parameter m04 )
  m05=$( get_parameter m05 )
  echo $m00:$m01:$m02:$m03:$m04:$m05 > $acl_list
  
  m10=$( get_parameter m10 )
  m11=$( get_parameter m11 )
  m12=$( get_parameter m12 )
  m13=$( get_parameter m13 )
  m14=$( get_parameter m14 )
  m15=$( get_parameter m15 )
  echo $m10:$m11:$m12:$m13:$m14:$m15 >> $acl_list
  
  m20=$( get_parameter m20 )
  m21=$( get_parameter m21 )
  m22=$( get_parameter m22 )
  m23=$( get_parameter m23 )
  m24=$( get_parameter m24 )
  m25=$( get_parameter m25 )
  echo $m20:$m21:$m22:$m23:$m24:$m25 >> $acl_list 
     
  m30=$( get_parameter m30 )
  m31=$( get_parameter m31 )
  m32=$( get_parameter m32 )
  m33=$( get_parameter m33 )
  m34=$( get_parameter m34 )
  m35=$( get_parameter m35 )
  echo $m30:$m31:$m32:$m33:$m34:$m35 >> $acl_list  
    
  m40=$( get_parameter m40 )
  m41=$( get_parameter m41 )
  m42=$( get_parameter m42 )
  m43=$( get_parameter m43 )
  m44=$( get_parameter m44 )
  m45=$( get_parameter m45 )
  echo $m40:$m41:$m42:$m43:$m44:$m45 >> $acl_list 
    
  m50=$( get_parameter m50 )
  m51=$( get_parameter m51 )
  m52=$( get_parameter m52 )
  m53=$( get_parameter m53 )
  m54=$( get_parameter m54 )
  m55=$( get_parameter m55 )
  echo $m50:$m51:$m52:$m53:$m54:$m55 >> $acl_list  
fi

echo "#" >> $main_conf
echo "# bridge parameters" >> $main_conf
echo "#------------------" >> $main_conf
kdhcpc=$( get_parameter p6 )
echo "kdhcpc="$kdhcpc >> $main_conf
if ! [ $kdhcpc == 1 ]; then
  # get IP for ath0 (ibr<0-3>)
  ibr0=$( get_parameter ibr0 )
  ibr1=$( get_parameter ibr1 )
  ibr2=$( get_parameter ibr2 )
  ibr3=$( get_parameter ibr3 )  
  IP_br0=$ibr0.$ibr1.$ibr2.$ibr3
  MASK_br0=$( get_parameter p7 )
  dgw0=$( get_parameter dgw0 )
  dgw1=$( get_parameter dgw1 )
  dgw2=$( get_parameter dgw2 )
  dgw3=$( get_parameter dgw3 )
  # get IP for nameserver1
  ns10=$( get_parameter ns10 )
  ns11=$( get_parameter ns11 )
  ns12=$( get_parameter ns12 )
  ns13=$( get_parameter ns13 )
  echo "IP_br0="$IP_br0 >> $main_conf
  echo "MASK_br0="$MASK_br0 >> $main_conf  
  echo "DFGW="$dgw0.$dgw1.$dgw2.$dgw3 >> $main_conf
  echo "NAMESERVER="$ns10.$ns11.$ns12.$ns13 >> $main_conf
fi
echo "# have fun! " >> $main_conf

chmod 755 $main_conf
sleep 1

# run options control
if [ $with_Simlink == 1 ]; then
  cleanWrap=/etc/init.d/S98ponte2
  cat > $cleanWrap << EOF
#!/bin/sh
$run_string
EOF
  chmod 755 $cleanWrap
fi

case $wrapper in
  1) 
  cleanWrap=/tmp/wrapper_ponte2wb.sh
  cat > $cleanWrap << EOF
#!/bin/sh
# run $run_string
$run_string
EOF
  chmod 755 $cleanWrap
  exec $cleanWrap  
  ;;
  2)
  cat $main_conf
  ;;
esac

cat <<EOF
Content-type: text/html
</pre>
</body></html>
EOF

# have fun!



